#import <objc/Object.h>

/* the Escaper class is used to perform the escape functions
   of tip3.  It was made a class so that scripts could be
   more easily implemented */

enum escapeFunction {
  nop, stop, protocol, parity, sendfile, receivefile,
  capture, hangup, readscript, baudrate, echo, say, expect, dial};

@interface Escaper:Object
{
  id term;
  id modem;
  enum escapeFunction keymap[128];  // holds the bindings
}

+ newEscaperWithTerm:(id)t andModem:(id)m;

- doFunction:(enum escapeFunction) func withInput:(id)source;
- doEscape:(char) func;
- bindChar:(char) ch toFunction:(enum escapeFunction) func;
- readScript:(char *)file;
- autoDial:(char *)dialString;

@end
