#import <sys/types.h>
#import <objc/Object.h>

@interface Fdset:Object
{
  fd_set fds;        // holds the file descriptors this set will wait on
  fd_set ready_fds;  // holds only those file descriptors which are ready for reading
  int nfds;          // the largest fd in the set plus 1
}

+ new;
- addfd:(int)thisfd;
- (BOOL) isfdReady:(int)thisfd; // returns YES if given descriptor is ready
- (int) waitOnInputForever;  // returns number of file descriptors which are ready
- (int) waitOnInputFor:(int)seconds;  //waits no more than number of seconds
- (int) waitOnInputFor:(int)seconds :(int)microseconds;  // for fractional timeouts
- (int) getReadyfd;  //returns one of the ready file descriptors, marks it unready

@end
