#import "Tty.h"

enum protocol {xmodem, xmodem1k, ymodem, zmodem};
enum direction {tohost, fromhost};

@interface Modem:Tty
{
  int capturefd;
  enum protocol receiveProt, sendProt;
}

+ newA;    // will open serial port A
+ newB;    // will open serial port B
+ newPort:(char *)dev speed:(int)bps;
- hangup;
- forkExecArgv:(char **)argv;   // this is called by other methods
- receiveZmodem;
- sendZmodemFile:(char *)filename;
- receiveYmodem;
- sendYmodemFile:(char *)filename;
- receiveXmodemFile:(char *)filename;
- sendXmodemFile:(char *)filename;
- receiveXmodem1kFile:(char *)filename;
- sendXmodem1kFile:(char *)filename;
- receive;
- sendFile:(char *)filename;
- setProtocol:(char)p dir:(enum direction)dir;
- (int) getProtocolDir:(enum direction)dir;
- captureSessionInFile:(char *)filename;
- endCapture;
- (BOOL) isCapturing;
- (int) readInto:(char *)buf;  //returns number of characters read into buf
- (int) writeOut:(char *)buf paced:(unsigned long)delay;

@end
