#import <objc/Object.h>

/* the Source class is used to be an alternate source of input
  for tip3 escape functions.  Thus, the arguments to some command
  in a script file are used to create a Source instance, which is
  passed to the Escaper method */

@interface Source:Object
{
  char **lines;
  int nlines;
  int lp;      // current line pointer
}

+ newStrings:(char **)s;

- (int)getchar;
- (int)getcharWithPrompt:(char *)prompt;
- (int)getline:(char *)string size:(int)max;
- (int)getline:(char *)string size:(int)max WithPrompt:(char *)prompt;
- putString:(char *)string; // no op for Source
- free;

@end
